<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
 {
       field: 'dicid',
       label: '分类编号',
       component: 'Input',
     },
     {
       field: 'dicname',
       label: '分类名称',
       component: 'Input',
     },
     {
       field: 'dicvalue',
       label: '分类值',
       component: 'Input',
     },
     {
       field: 'parentname',
       label: '上级分类',
       component: 'Input',
     },
     {
       field: 'description',
       label: '分类描述',
       component: 'Input',
     },
     {
       field: 'status',
       label: '分类状态',
       component: 'Input',
     }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

